<?php
  session_start();

//sample URL:
//https://your_domain.com/php_gn_natal_public/natal.php?ss=4&n=Allen&m=9&d=22&y=1949&h=10&min=43&tz=-6&long_deg=95&long_min=23&ew=w&lat_deg=29&lat_min=45&ns=n&ubt=0

  $error_reporting = error_reporting(E_ALL & ~E_NOTICE);
  date_default_timezone_set('America/Denver');
  $server_name = strtolower($_SERVER['SERVER_NAME']);

  if ($server_name == "localhost" Or $server_name == "zzee.php.gui") { $_GET['ss'] = 4; }

  // check if the form has been submitted
  if (isset($_GET['ss']))
  {
    // get all variables from form
    $name = safeEscapeString($_GET["n"]);

    $month = intval($_GET["m"]);
    $day = intval($_GET["d"]);
    $year = intval($_GET["y"]);

    $hour = intval($_GET["h"]);
    $minute = intval($_GET["min"]);

    $timezone = safeEscapeString($_GET["tz"]);

    $ubt = intval($_GET["ubt"]);

    $long_deg = intval($_GET["long_deg"]);
    $long_min = intval($_GET["long_min"]);
    $ew = safeEscapeString($_GET["ew"]);

    $lat_deg = intval($_GET["lat_deg"]);
    $lat_min = intval($_GET["lat_min"]);
    $ns = safeEscapeString($_GET["ns"]);

    //=============================================================================================

    if ($server_name == "localhost" Or $server_name == "zzee.php.gui")
    {
      $name = "Allen";

      $month = 9;
      $day = 22;
      $year = 1949;

      $hour = 10;
      $minute = 43;

      $timezone = -6;

      $ubt = 0;

      $long_deg = 95;
      $long_min = 23;
      $ew = "w";

      $lat_deg = 29;
      $lat_min = 45;
      $ns = "n";
    }

    //=============================================================================================

    // additional error checks on user-entered data
    if ($month == 0) { $my_error .= "Please enter a month.<br>"; }

    if ($month != "" And $day != "" And $year != "")
    {
      if (!$date = checkdate(settype ($month, "integer"), settype ($day, "integer"), settype ($year, "integer"))) { $my_error .= "The date of birth you entered is not valid.<br>"; }
    }

    if (($year < 1800) Or ($year >= 2400)) { $my_error .= "Please enter a year between 1800 and 2399.<br>"; }
    if (($hour < 0) Or ($hour > 23)) { $my_error .= "Birth hour must be between 0 and 23.<br>"; }
    if (($minute < 0) Or ($minute > 59)) { $my_error .= "Birth minute must be between 0 and 59.<br>"; }
    if (($long_deg < 0) Or ($long_deg > 179)) { $my_error .= "Longitude degrees must be between 0 and 179.<br>"; }
    if (($long_min < 0) Or ($long_min > 59)) { $my_error .= "Longitude minutes must be between 0 and 59.<br>"; }
    if (($lat_deg < 0) Or ($lat_deg > 75)) { $my_error .= "Latitude degrees must be between 0 and 75.<br>"; }
    if (($lat_min < 0) Or ($lat_min > 59)) { $my_error .= "Latitude minutes must be between 0 and 59.<br>"; }
    if (($ew == '-1') And ($timezone > 2)) { $my_error .= "You have marked West longitude but set an east time zone.<br>"; }
    if (($ew == '1') And ($timezone < 0)) { $my_error .= "You have marked East longitude but set a west time zone.<br>"; }

    //=============================================================================================

    if (strtolower($ew) == "w")
    {
      $ew = -1; $ew_txt = "w";
    }
    else
    {
      $ew = 1; $ew_txt = "e";
    }

    if (strtolower($ns) == "n")
    {
      $ns = 1; $ns_txt = "n";
    }
    else
    {
      $ns = -1; $ns_txt = "s";
    }

    //=============================================================================================

    if (($my_error != ""))
    {
      echo "<table align='center' width='98%' border='0' cellspacing='15' cellpadding='0'><tr><td><center><b>";
      echo "<font color='#ff0000' size=+2>Error! - The following error(s) occurred:</font><br><br>";

      echo "<font size='+1'>" . $my_error . "</font></b></center></td></tr></table>";
    }
    else
    {
      $swephsrc = './sweph';
      $sweph = './sweph';

      putenv("PATH=$PATH:$swephsrc");

      $h_sys = "P";
      
      if ($lat_deg >= 66) { $h_sys = "O"; }

      //unset any variables not initialized elsewhere in the program
      unset($PATH,$out,$pl_name,$longitude1,$house_pos);

      //assign data from database to local variables
      $inmonth = $month;
      $inday = $day;
      $inyear = $year;
      
      record_the_year($inyear);

      $inhours = $hour;
      $inmins = $minute;
      $insecs = "0";

      $intz = $timezone;

      $my_longitude = $ew * ($long_deg + ($long_min / 60));
      $my_latitude = $ns * ($lat_deg + ($lat_min / 60));

      $abs_tz = abs($intz);
      $the_hours = floor($abs_tz);
      $fraction_of_hour = $abs_tz - floor($abs_tz);
      $the_minutes = 60 * $fraction_of_hour;
      $whole_minutes = floor(60 * $fraction_of_hour);
      $fraction_of_minute = $the_minutes -$whole_minutes;
      $whole_seconds = round(60 * $fraction_of_minute);

      if ($intz >= 0)
      {
        $inhours = $inhours - $the_hours;
        $inmins = $inmins - $whole_minutes;
        $insecs =  $insecs - $whole_seconds;
        $tz_txt = "+" . $intz;
      }
      else
      {
        $inhours = $inhours + $the_hours;
        $inmins = $inmins + $whole_minutes;
        $insecs =  $insecs + $whole_seconds;
        $tz_txt = $intz;
      }


      //gather data in order to create a file name for the chartwheel graphic
      $restored_name = stripslashes($name);
      $filename = $restored_name . "_" . strftime("%Y_%m_%d_%H_%M_tz=$intz" . "_", mktime($hour, $inmins, $insecs, $inmonth, $inday, $inyear));
      $filename .= $long_deg . $ew_txt . sprintf("%02d", $long_min) . "_" . $lat_deg . $ns_txt . sprintf("%02d", $lat_min) . ".png";

      $line1 = $restored_name;
      $line2 = strftime("%A, %B %d, %Y", mktime($hour, $minute, $insecs, $inmonth, $inday, $inyear));
      $line3 = strftime("%H:%M (GMT $tz_txt hours)", mktime($hour, $minute, $insecs, $inmonth, $inday, $inyear));
      $line4 = $long_deg . $ew_txt . sprintf("%02d", $long_min) . ", " . $lat_deg . $ns_txt . sprintf("%02d", $lat_min);

      $chartwheel_filename = "./charts/" . $filename;

      $_SESSION['chartwheel_filename'] = $chartwheel_filename;


      // adjust date and time for minus hour due to time zone taking the hour negative
      $utdatenow = strftime("%d.%m.%Y", mktime($inhours, $inmins, $insecs, $inmonth, $inday, $inyear));
      $utnow = strftime("%H:%M:%S", mktime($inhours, $inmins, $insecs, $inmonth, $inday, $inyear));

      exec ("swetest -edir$sweph -b$utdatenow -ut$utnow -p0123456789Dt -eswe -house$my_longitude,$my_latitude,$h_sys -flsj -g, -head", $out);

      foreach ($out as $key => $line)
      {
        $row = explode(',',$line);
        $longitude1[$key] = $row[0];
        $speed1[$key] = $row[1];
        $house_pos1[$key] = $row[2];
      };


      include("constants_v3.php");         // this is here because we must rename the planet names


      if ($ubt == 1)
      {
        $longitude1[1 + LAST_PLANET] = 0;       //make flat chart with natural houses
        $longitude1[2 + LAST_PLANET] = 30;
        $longitude1[3 + LAST_PLANET] = 60;
        $longitude1[4 + LAST_PLANET] = 90;
        $longitude1[5 + LAST_PLANET] = 120;
        $longitude1[6 + LAST_PLANET] = 150;
        $longitude1[7 + LAST_PLANET] = 180;
        $longitude1[8 + LAST_PLANET] = 210;
        $longitude1[9 + LAST_PLANET] = 240;
        $longitude1[10 + LAST_PLANET] = 270;
        $longitude1[11 + LAST_PLANET] = 300;
        $longitude1[12 + LAST_PLANET] = 330;
      }


      //get house positions of planets here
      for ($x = 1; $x <= 12; $x++)
      {
        for ($y = 0; $y <= LAST_PLANET; $y++)
        {
          $pl = $longitude1[$y] + (1 / 36000);
          if ($x < 12 And $longitude1[$x + LAST_PLANET] > $longitude1[$x + LAST_PLANET + 1])
          {
            if (($pl >= $longitude1[$x + LAST_PLANET] And $pl < 360) Or ($pl < $longitude1[$x + LAST_PLANET + 1] And $pl >= 0))
            {
              $house_pos1[$y] = $x;
              continue;
            }
          }

          if ($x == 12 And ($longitude1[$x + LAST_PLANET] > $longitude1[LAST_PLANET + 1]))
          {
            if (($pl >= $longitude1[$x + LAST_PLANET] And $pl < 360) Or ($pl < $longitude1[LAST_PLANET + 1] And $pl >= 0))
            {
              $house_pos1[$y] = $x;
            }
            continue;
          }

          if (($pl >= $longitude1[$x + LAST_PLANET]) And ($pl < $longitude1[$x + LAST_PLANET + 1]) And ($x < 12))
          {
            $house_pos1[$y] = $x;
            continue;
          }

          if (($pl >= $longitude1[$x + LAST_PLANET]) And ($pl < $longitude1[LAST_PLANET + 1]) And ($x == 12))
          {
            $house_pos1[$y] = $x;
          }
        }
      }


      $secs = "0";

      $tz = "+" . $timezone;
      if ($timezone < 0) { $tz = $timezone; }

      if ($ubt == 0)
      {
        $profile_birthdata = strftime("%B %d, %Y at %H:%M (GMT $tz hours), ", mktime(intval($hour), intval($minute), intval($secs), intval($month), intval($day), intval($year)));
      }
      else
      {
        $profile_birthdata = strftime("%B %d, %Y at time unknown (GMT $tz hours), ", mktime(intval($hour), intval($minute), intval($secs), intval($month), intval($day), intval($year)));
      }

      $profile_birthdata .= $long_deg . $ew_txt . sprintf("%02d", $long_min) . ", " . $lat_deg . $ns_txt . sprintf("%02d", $lat_min);

      $rx1 = "";
      for ($i = 0; $i <= SE_TNODE; $i++)
      {
        if ($speed1[$i] < 0)
        {
          $rx1 .= "R";
        }
        else
        {
          $rx1 .= " ";
        }
      }

      for ($i = 1; $i <= 12; $i++)
      {
        $hc1[$i] = $longitude1[LAST_PLANET + $i];
      }

      $_SESSION['nL1'] = $longitude1;
      $_SESSION['nHC1'] = $hc1;
      $_SESSION['nH1'] = $house_pos1;

      include ('natal_wheel_3.php');           //create the chartwheel

      include ('create_natal_pdf_v3.php');             //create a .pdf file

      exit();
    }
  }

  include ('footer.html');

  exit();


Function left($leftstring, $leftlength)
{
  return(substr($leftstring, 0, $leftlength));
}


Function Reduce_below_30($longitude)
{
  $lng = $longitude;

  while ($lng >= 30)
  {
    $lng = $lng - 30;
  }

  return $lng;
}


Function Convert_Longitude($longitude)
{
  $signs = array (0 => 'Ari', 'Tau', 'Gem', 'Can', 'Leo', 'Vir', 'Lib', 'Sco', 'Sag', 'Cap', 'Aqu', 'Pis');

  $sign_num = floor($longitude / 30);
  $pos_in_sign = $longitude - ($sign_num * 30);
  $deg = floor($pos_in_sign);
  $full_min = ($pos_in_sign - $deg) * 60;
  $min = floor($full_min);
  $full_sec = round(($full_min - $min) * 60);

  if ($deg < 10) { $deg = "0" . $deg; }

  if ($min < 10) { $min = "0" . $min; }

  if ($full_sec < 10) { $full_sec = "0" . $full_sec; }

  return $deg . " " . $signs[$sign_num] . " " . $min . "' " . $full_sec . chr(34);
}


Function mid($midstring, $midstart, $midlength)
{
  return(substr($midstring, $midstart-1, $midlength));
}


Function safeEscapeString($inp)
{
  if(is_array($inp))
    return array_map(__METHOD__, $inp);

  $temp1 = str_replace("<", "[", $inp);
  $temp2 = str_replace(">", "]", $temp1);

  $temp1 = str_replace("[br]", "<br />", $temp2);
  $temp2 = str_replace("[br /]", "<br />", $temp1);

  if(!empty($temp2) && is_string($temp2))
  {
    return str_replace(array('\\', "\0", "\n", "\r", "'", '"', "\x1a"), array('\\\\', '\\0', '\\n', '\\r', "\\'", '\\"', '\\Z'), $temp2);
  }

  return $temp2;
}


Function record_the_year($year)
{
  if ($year < 1970)
  {
    $filename = "year_below_1970.txt";
  }
  else
  {
    $filename = "year_1970_or_higher.txt";
  }

  $cnt = file("../" . $filename, FILE_IGNORE_NEW_LINES);

  $cnt[0]++;

  $fh = fopen("../" . $filename, "w+");

  fwrite($fh, $cnt[0] . "\n");

  fclose($fh);
}

?>
